function komargrab(vid)

global komar_vid komar_write
global komar_dir komar_fmt
global komar_idx komar_max komar_buffer komar_times
global komar_laser_sigma;
global komar_detector_scale;
global komar_finished;
global komar_lock;
global komar_chk;
global komar_txt;
global komar_img;
global komar_time;
global komar_halfsize;
global komar_halfframe;
global komar_count;
%
%
komar_lock = 0;
komar_finished = false;
komar_vid = vid;
%komar_size = 0.5; % downsample images
komar_write = 0; % 0:memory, 1:file
komar_laser_sigma = 40; % variance of the laser, in pixels
komar_detector_scale = 0.5; % downscaling of the image for the reference detector

% write 1
komar_dir = 'C:\Documents and Settings\defuser';
komar_fmt = '.bmp';

% write 0
komar_count = 0;
komar_idx = 0;
komar_max = 4000; % number of frames to save in memory

vidRes = get(vid, 'VideoResolution'); 
nBands = get(vid, 'NumberOfBands');
if nBands==1
	imWidth = vidRes(1)/2;
	imHeight = vidRes(2)/2;
else
	imWidth = vidRes(1);
	imHeight = vidRes(2);
end
komar_halfsize = false;
komar_halfframe = true;
if imWidth > 320
	komar_halfsize = true;
	komar_halfframe = false;
end
if komar_halfsize
	imWidth = imWidth/2;
	imHeight = imHeight/2;
end
imBands = 3;
komar_halfframe = false;
%
%komar_buffer = zeros([imHeight, imWidth, imBands, komar_max], 'uint8');
komar_buffer = cell(1,komar_max);
komar_times = cell(1,komar_max);

hFig = figure('Toolbar','none','Menubar', 'none','NumberTitle','Off','Name','Komar grabber');
%hFig = figure('NumberTitle','Off','Name','Komar grabber');

set(hFig,'CloseRequestFcn',@komarclose_fcn);

%snap = getsnapshot(vid);
%axis equal;

komar_img = image(zeros(imHeight,imWidth,imBands,'uint8')); hold on;
hImage = image(zeros(vidRes(2), vidRes(1), nBands,'uint8'),'Visible','off');%image(zeros(960, 1280, 1,'uint8'));
%set(hImage,'Visible','off'); 
%hold on;% hide preview
axis off;
%uicontrol('String', 'Stop','Callback', 'komarstop_fcn','Units','normalized','Position',[.06 0.5 .25 0.5]);
%uicontrol('String', 'Save','Callback', 'komarprocess_fcn','Units','normalized','Position',[.37 0.5 .25 0.5]);
%uicontrol('String', 'Close','Callback', 'komarclose_fcn','Units','normalized','Position',[.68 0.5 .25 0.5]);
%uicontrol('String', 'Stop All','Callback', 'komarstopall_fcn','Units','normalized','Position',[.06 0 .25 0.5]);
ssz = get(0,'MonitorPosition');
h = 400; bw = 100; bh = 40;
set(hFig,'unit','pixels','position',[80 ssz(4)-h-20 500 h]);
%
c = uicontrol('String', 'Stop','Callback', 'komarstop_fcn','Units','pixels','Position',[0 h-bh bw bh*.9]);
set(c,'Units','normalized');
%set(c,'Enable','off')
c = uicontrol('String', 'Save','Callback', 'komarprocess_fcn','Units','pixels','Position',[0 h-bh*2 bw bh*0.9]);
set(c,'Units','normalized');
c = uicontrol('String', 'Stop All','Callback', 'komarstopall_fcn','Units','pixels','Position',[0 h-bh*4 bw bh*0.9]);
set(c,'Units','normalized');
c = uicontrol('String', 'Close','Callback', 'komarclose_fcn','Units','pixels','Position',[0 h-bh*3 bw bh*0.9]);
set(c,'Units','normalized');
c = uicontrol('Style', 'checkbox','String','Fast Preview','Value',0,'Units','pixels','Position',[0 h-bh*4 bw bh*0.9]);
set(c,'Units','normalized');
komar_chk = c;
c = uicontrol('String','FPS: ','Units','pixels','Position',[0 h-bh*5 bw bh*0.9]);
set(c,'Units','normalized');
komar_txt = c;
c = uicontrol('String','Time: ','Units','pixels','Position',[0 h-bh*6 bw bh*0.9]);
set(c,'Units','normalized');
komar_time = c;
%
ffit;

%figSize = get(hFig,'Position');
%set(gca,'unit','pixels',...
%        'position',[ ((figSize(3) - imWidth)/2)...
%                     ((figSize(4) - imHeight)/2)...
%                       imWidth imHeight ]);

% Set up the update preview window function.
%
setappdata(hImage,'UpdatePreviewWindowFcn',@komargrab_fcn);
%
preview(vid, hImage);
end
