function komargrab_fcn(obj,event,himage)

global komar_write
global komar_dir komar_fmt
global komar_idx komar_max komar_buffer komar_times
global komar_finished
global komar_lock;
global komar_chk;
global komar_txt;
global komar_img;
global komar_time;
global komar_halfsize;
global komar_halfframe;
global komar_count;

% if komar_lock %% this is to discard duplicate/black images
% 	komar_lock = 0;
% 	return;
% end
%
%
% if komar_idx>0
%     last_time = komar_times(komar_idx);
%     t1 = datevec(datenum(last_time,'HH:MM:SS.FFF'));
%     t2 = datevec(datenum(event.Timestamp,'HH:MM:SS.FFF'));
%     tt = etime(t2,t1);
%     %fprintf('%3.5f\n',tt);
%     if(tt < 0.5*1/15)
%         return;
%     end
% end

%if (event.Data(1,1)>0) && (event.Data(1,2)>0) && (event.Data(2,1)>0) && (event.Data(2,2)>0) % is non-black

%  im = zeros(240,320,3,'uint8');
%  im(:,:,1) = event.Data(2:4:end,1:4:end);
%  im(:,:,2) = event.Data(1:4:end,1:4:end);
%  im(:,:,3) = event.Data(1:4:end,2:4:end);
komar_count = komar_count + 1;

if komar_halfframe && mod(komar_count,2) == 0
	return;
end

if(size(event.Data,3)==1)
	rgb = quick_rgb_mex(event.Data);
else
	rgb = event.Data;
end
if komar_halfsize
	im = quick_scale_mex(rgb,2);
else
	im = rgb;
end
if (sum(im(:))==0)
	komar_lock = 0;
	return;
end

% preview
if(get(komar_chk,'Value')>0.5 || mod(komar_idx,5)==1)
	set(komar_img, 'CData', im);%zeros(size(im)));%im);
end
%
dt0=0;
% FPS and Time
if(komar_idx>15)
	n1 = komar_idx-15;
	n2 = komar_idx;
	t0 = datevec(datenum(komar_times{1},'HH:MM:SS.FFF'));
	t1 = datevec(datenum(komar_times{n1},'HH:MM:SS.FFF'));
	t2 = datevec(datenum(komar_times{n2},'HH:MM:SS.FFF'));
	dt = etime(t2,t1);
	dt0 = etime(t2,t0);
	fps = (n2-n1+1)/dt;
	%
	set(komar_txt,'String',sprintf('FPS: %3.2f',fps));
	set(komar_time,'String',sprintf('Time: %3.1fs',dt0));
	%
end
%
%return
%fprintf('.');
if komar_write
	fname = regexprep(event.Timestamp,':|\.','');
	imwrite(im,[komar_dir filesep fname komar_fmt]);
elseif komar_idx < komar_max
	komar_idx = komar_idx+1;
	%komar_buffer(:,:,:,komar_idx) = im;
	komar_buffer{komar_idx} = im;
	komar_times{komar_idx} = event.Timestamp;
end
%
if komar_idx >= komar_max || dt0>120 % = 2 minutes
	if ~komar_finished
		komar_finished = true;
		commandwindow();
		t1 = datevec(datenum(komar_times{1},'HH:MM:SS.FFF'));
		t2 = datevec(datenum(komar_times{komar_idx},'HH:MM:SS.FFF'));
		dt = etime(t2,t1);
		fps = komar_idx/dt;
		%fprintf('FPS: %3.5f\n',);
		fprintf(1,'KOMARgrab: Stopped(timeout or buffer full).\nFPS: %3.5f \nFlushing to disk.\n',fps);
		komarstop_fcn();
		komarprocess_fcn();
		%stop(vid);
		%delete vid;
	end
end
%
%fprintf(1,'%s\n',event.Timestamp); % write timestamps
%set(himage, 'CData', im); % show preview
%end
%komar_lock = 1;
return;
